'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (config) {
  return function (css) {
    const unwrappedConfig = config();

    css.walkAtRules('tailwind', atRule => {
      if (atRule.params !== 'utilities') {
        return;
      }

      const utilities = (0, _generateModules2.default)(_utilityModules2.default, unwrappedConfig.modules, unwrappedConfig);

      if (unwrappedConfig.options.important) {
        utilities.walkDecls(decl => decl.important = true);
      }

      const tailwindClasses = _postcss2.default.root({
        nodes: [...(0, _container2.default)(unwrappedConfig), ...utilities.nodes]
      });

      (0, _applyClassPrefix2.default)(tailwindClasses, unwrappedConfig.options.prefix);

      tailwindClasses.walk(node => node.source = atRule.source);

      atRule.before(tailwindClasses);
      atRule.remove();
    });
  };
};

var _postcss = require('postcss');

var _postcss2 = _interopRequireDefault(_postcss);

var _applyClassPrefix = require('../util/applyClassPrefix');

var _applyClassPrefix2 = _interopRequireDefault(_applyClassPrefix);

var _generateModules = require('../util/generateModules');

var _generateModules2 = _interopRequireDefault(_generateModules);

var _container = require('../generators/container');

var _container2 = _interopRequireDefault(_container);

var _utilityModules = require('../utilityModules');

var _utilityModules2 = _interopRequireDefault(_utilityModules);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }